#include "global.h"
#include "lcd.h"

void char2str(u16 data, char *s, u08 digits)
{
	u16 div;
	u08 i, c;
	char temp[5];

	div = 10000;

	for(i=0;i<5;i++)
	{
		c = 0;
		while(data >= div)
		{
			data -= div;
			c++;
		};

		temp[i] = c + '0';
		div /= 10;
 	}

 	for(i=0;i<digits;i++)
 	{
		s[i]=temp[i- digits + 5];
 	}
	s[i] = 0;
}

//void char2str(u16 data, char *s, u08 digits)
//{
//	u16 div;
//	u08 i, c, n;
//	char temp[5];
//
//	div = 10000;
//
//	for(i=0;i<5;i++)
//	{
//		c = data / div;
//		temp[i] = c + '0';
//		data -= c * div;
//		div /= 10;
// 	}
//
// 	for(i=0;i<digits;i++)
// 	{
//		s[i]=temp[i- digits + 5];
// 	}
//	s[i] = 0;
//}

void short_delay(void)
{
}

void long_delay(u16 delay)
{
	while(delay)
	{
		short_delay();
		delay--;
	};
}

void 	lcd_write_byte(u08 data, u08 control)
{
#ifndef LCD_BUS_8
	u08 temp;
#endif
	if(control == LCD_CONTROL)
	{
		cbi(PORT_LCD_CONTROL, LCD_RS);
	}
	else
	{
		sbi(PORT_LCD_CONTROL, LCD_RS);
	}
	cbi(PORT_LCD_CONTROL, LCD_RW); // Write Mode
	sbi(PORT_LCD_CONTROL, LCD_EN); // Enable ON

#ifdef LCD_BUS_8
	outp(data, PORT_LCD_DATA);
#else
	temp = inp(PORT_LCD_DATA);
	outp((temp & 0x0F) | (data & 0xF0), PORT_LCD_DATA);
//	outp((data & 0xF0), PORT_LCD_DATA);

	cbi(PORT_LCD_CONTROL, LCD_EN); // Enable OFF

	sbi(PORT_LCD_CONTROL, LCD_EN); // Enable ON
	temp = inp(PORT_LCD_DATA);
	outp((temp & 0x0F) | (data << 4), PORT_LCD_DATA);
	//outp((data << 4), PORT_LCD_DATA);
#endif
	cbi(PORT_LCD_CONTROL, LCD_EN); // Enable OFF
}

u08 lcd_read_byte(u08 control)
{
	u08 temp;
#ifndef LCD_BUS_8
	u08 temp2, temp_in;
#endif

#ifdef LCD_BUS_8
	outp(0xFF, PORT_LCD_DATA);		 	// Enable Pull-UP
	outp(0x00,DDR_LCD_DATA);        	// DDR Data-Bus OUT
#else
	temp_in = inp(PORT_LCD_DATA);
	outp((temp_in | 0xF0), PORT_LCD_DATA);
	temp_in = inp(DDR_LCD_DATA);
	outp(temp_in & 0x0F, DDR_LCD_DATA);
#endif

	if(control == LCD_CONTROL)
	{
	 	cbi(PORT_LCD_CONTROL, LCD_RS);
	}
	else
	{
		sbi(PORT_LCD_CONTROL, LCD_RS);
	}
	sbi(PORT_LCD_CONTROL, LCD_RW); // Read Mode
	sbi(PORT_LCD_CONTROL, LCD_EN); // Enable ON

#ifdef LCD_BUS_8
	short_delay();
//	delay = LCD_DELAY;
//	while(delay)
//	{
//		delay--;
//	};

	temp = inp(PIN_LCD_DATA);
#else
	short_delay();
//	delay = LCD_DELAY;
//	while(delay)
//	{
//		delay--;
//	};

	temp =  (inp(PIN_LCD_DATA)) & 0xF0;
	cbi(PORT_LCD_CONTROL, LCD_EN); // Enable OFF
	short_delay();
//	delay = LCD_DELAY;
//	while(delay)
//	{
//		delay--;
//	};

	sbi(PORT_LCD_CONTROL, LCD_EN); // Enable ON
	short_delay();
//	delay = LCD_DELAY;
//	while(delay)
//	{
//		delay--;
//	};
	temp2 = inp(PIN_LCD_DATA);
	temp = temp | ((temp2 >> 4) & 0x0F);
#endif
	cbi(PORT_LCD_CONTROL, LCD_EN); // Enable OFF
	cbi(PORT_LCD_CONTROL, LCD_RW); // Write Mode

#ifdef LCD_BUS_8
	outp(0xFF,DDR_LCD_DATA);        	// DDR Data-Bus OUT
#else
	temp_in = inp(DDR_LCD_DATA);
	outp(temp_in | 0xF0, DDR_LCD_DATA);
#endif
	return temp;
}

void lcd_wait_busy()
{
	u08 data;
	u16 timeout;

	timeout = LCD_TIMEOUT;
	do
	{
		data = lcd_read_byte(LCD_CONTROL);
		timeout--;
	}
	while((data & 0x80) && timeout);
}

void lcd_init()
{
//	u16 delay;
#ifdef COLDSTART
	u08 startup;
#endif
#ifndef LCD_BUS_8
	u08 temp;
#endif
#ifdef LCD_BUS_8
	outp(0xFF,DDR_LCD_DATA);        	// DDR Data-Bus OUT
#else
	temp = inp(DDR_LCD_DATA);
	outp(temp | 0xF0, DDR_LCD_DATA);
#endif

	sbi(DDR_LCD_CONTROL, LCD_RS);	 	// Control Lines to OUT
	sbi(DDR_LCD_CONTROL, LCD_RW);		// Control Lines to OUT
	sbi(DDR_LCD_CONTROL, LCD_EN);		// Control Lines to OUT

	cbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable OFF
	cbi(PORT_LCD_CONTROL, LCD_RW); 	// Write Mode
	cbi(PORT_LCD_CONTROL, LCD_RS);	// Control Select

#ifdef COLDSTART
	for(startup=3;startup > 0;startup--)
	{
//		delay = (STARTUP_FACTOR * (1 << (startup * 2)));
//		while(delay)
//		{
//			short_delay();
//			delay--;
//		};
		long_delay(STARTUP_FACTOR * (1 << (startup * 2)));

		cbi(PORT_LCD_CONTROL, LCD_RS);	// Control Select
		sbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable ON
#ifdef LCD_BUS_8
		outp(0x3A, PORT_LCD_DATA);
#else
		temp = inp(PORT_LCD_DATA);
		outp((temp & 0x0F) | 0x30, PORT_LCD_DATA);
#endif
//		delay = STARTUP_FACTOR;
//		while(delay)
//		{
//			short_delay();
//			delay--;
//		};
		long_delay(STARTUP_FACTOR);

		cbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable OFF

//		delay = STARTUP_FACTOR;
//		while(delay)
//		{
//			short_delay();
//			delay--;
//		};
		long_delay(STARTUP_FACTOR);
	}
#endif

#ifdef LCD_BUS_8
	cbi(PORT_LCD_CONTROL, LCD_RS);	// Control Select
	sbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable ON
	outp(0x3A, PORT_LCD_DATA);
//	delay = STARTUP_FACTOR;
//	while(delay)
//	{
//		short_delay();
//		delay--;
//	};
	long_delay(STARTUP_FACTOR);

	cbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable OFF
#else
	cbi(PORT_LCD_CONTROL, LCD_RS);	// Control Select
	sbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable ON
	temp = inp(PORT_LCD_DATA);
	outp((temp & 0x0F) | 0x20, PORT_LCD_DATA);
//	delay = STARTUP_FACTOR;
//	while(delay)
//	{
//		short_delay();
//		delay--;
//	};
	long_delay(STARTUP_FACTOR);

	cbi(PORT_LCD_CONTROL, LCD_EN); 	// Enable OFF
#endif

//	delay = STARTUP_FACTOR;
//	while(delay)
//	{
//		short_delay();
//		delay--;
//	};
	long_delay(STARTUP_FACTOR);

#ifdef LCD_TWO_LINES
	#ifdef LCD_BUS_8
		lcd_write_byte(0x3A, LCD_CONTROL);
	#else
		lcd_write_byte(0x2A, LCD_CONTROL);
	#endif
#else
	#ifdef LCD_BUS_8
		lcd_write_byte(0x32, LCD_CONTROL);
	#else
		lcd_write_byte(0x22, LCD_CONTROL);
	#endif
#endif

	lcd_wait_busy();
	lcd_write_byte(0x06, LCD_CONTROL);
}

void lcd_clear()
{
	lcd_wait_busy();
	lcd_write_byte(0x01 ,LCD_CONTROL);
}

void lcd_mode(u08 mode)
{
	lcd_wait_busy();
	lcd_write_byte(mode, LCD_CONTROL);
}

#ifdef LCD_SETCHAR
void lcd_setchar(u08 code, u08 row, u08 data)
{
	lcd_wait_busy();
	lcd_write_byte((code << 3) | row | 0x40, LCD_CONTROL);

	lcd_wait_busy();
	lcd_write_byte(data & 0x1F, LCD_DATA);
}
#endif

void lcd_puts(char *data)
{
	u08 pos;

	pos = 0;
	while(data[pos] != 0x00)
	{
		lcd_wait_busy();
		lcd_write_byte(data[pos], LCD_DATA);
		pos++;
	}
}

void lcd_puts_P(char *data)
{
	u08 pos;

	pos = 0;
	while(PRG_RDB(&data[pos]) != 0x00)
	{
		lcd_wait_busy();
		lcd_write_byte(PRG_RDB(&data[pos]), LCD_DATA);
		pos++;
	}
}

void lcd_gotoxy(u08 x, u08 y)
{
	u08 adr;
	adr = 0;
	adr = (0x80 | (x-1) | ((y-1)<<6));
	lcd_wait_busy();
	lcd_write_byte(adr, LCD_CONTROL);
}
